import StringHelper from "../services/string-helper.mjs";

function SubscriptionPage() {
    const endpoints = {
        'subscription': `${jims_wpcb_variables.home_url}/wp-json/jims-wpcb/v1/email-subscription/create`,
        'is_subscribed': `${jims_wpcb_variables.home_url}/wp-json/jims-wpcb/v1/email-subscription/subscribed`,
        'subscription_data': `${jims_wpcb_variables.home_url}/wp-json/jims-wpcb/v1/email-subscription/get`
    };

    const _d = document;
    const Str = new StringHelper();


    const form = _d.querySelector('#jims-subscription-form');
    const message = form.querySelector('.message');
    message.innerHTML = '';

    if (form) {
        getData(form).then((data) => {
            form.querySelector('input[name=email]').value = data.email;
            form.querySelector('input[name=name]').value = data.name;
        });
    } else {
        throw new Error('Form not found');
    }

    form.addEventListener('submit', (evt) => {
        evt.preventDefault();
        let formdata = new FormData(form);

        form.querySelector('input#save-form').classList.add('disabled');

        SaveData(Str.formatMessage(formdata), form).then(r => {
            form.querySelector('input#save-form').classList.remove('disabled');
            message.innerHTML = 'Data Saved';
        });

        return false;
    });

    async function getData(form) {
        const rawResponse = await fetch(endpoints.subscription_data);
        const content = await rawResponse.json();
        console.log(content);
        return content;
    }

    async function SaveData(data, formElement) {
        const rawResponse = await fetch(endpoints.subscription, {
            method: 'POST',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        });


        const content = await rawResponse.json();
        formElement.querySelector('input[type=submit]').classList.remove('disabled');
        console.log(content);
    }
}


export default SubscriptionPage;