<?php

namespace JimsCustomerBooking\RestfulAPI;

use JimsCustomerBooking\Helpers\HashHelper;
use JimsCustomerBooking\Jims_Plugin;


use Defuse\Crypto\Key;

class ScheduleController extends RestController implements IRestfulController
{
    protected $route = 'schedule';

    public function register_routes(){
        $namespace = $this->get_namespace();

        register_rest_route( $namespace, $route = '/' . $this->get_route () . '/create', [
            [
                'methods' => \WP_REST_Server::CREATABLE,
                'callback' => array($this, 'set_schedule'),
                'permission_callback' => [$this, 'checkPermissions'],
            ]
        ]);
    }


    public function set_schedule($request): \WP_REST_Response
    {
        $text = $request->get_param('text');

        try {
            $encryptedText = HashHelper::deHash($text, Jims_Plugin::ENCRYPTION_KEY);
        } catch (\Exception $e) {
            return new \WP_REST_Response([
                'error' => $e->getMessage()
            ], 500);
        }


        return new \WP_REST_Response([
            'encrypted_text' => $encryptedText
        ], 200);
    }
}